///base64
var BangBangAndLite=function (){
    var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var base64DecodeChars = new Array(-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1);
    /**
     * base64编码
     * @param {Object} str
     */
    function base64encode(str){
        var out, i, len;
        var c1, c2, c3;
        len = str.length;
        i = 0;
        out = "";
        while (i < len) {
            c1 = str.charCodeAt(i++) & 0xff;
            if (i == len) {
                out += base64EncodeChars.charAt(c1 >> 2);
                out += base64EncodeChars.charAt((c1 & 0x3) << 4);
                out += "==";
                break;
            }
            c2 = str.charCodeAt(i++);
            if (i == len) {
                out += base64EncodeChars.charAt(c1 >> 2);
                out += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
                out += base64EncodeChars.charAt((c2 & 0xF) << 2);
                out += "=";
                break;
            }
            c3 = str.charCodeAt(i++);
            out += base64EncodeChars.charAt(c1 >> 2);
            out += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
            out += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6));
            out += base64EncodeChars.charAt(c3 & 0x3F);
        }
        return out;
    }
    /**
     * base64解码
     * @param {Object} str
     */
    function base64decode(str){
        var c1, c2, c3, c4;
        var i, len, out;
        len = str.length;
        i = 0;
        out = "";
        while (i < len) {
            /* c1 */
            do {
                c1 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
            }
            while (i < len && c1 == -1);
            if (c1 == -1) 
                break;
            /* c2 */
            do {
                c2 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
            }
            while (i < len && c2 == -1);
            if (c2 == -1) 
                break;
            out += String.fromCharCode((c1 << 2) | ((c2 & 0x30) >> 4));
            /* c3 */
            do {
                c3 = str.charCodeAt(i++) & 0xff;
                if (c3 == 61) 
                    return out;
                c3 = base64DecodeChars[c3];
            }
            while (i < len && c3 == -1);
            if (c3 == -1) 
                break;
            out += String.fromCharCode(((c2 & 0XF) << 4) | ((c3 & 0x3C) >> 2));
            /* c4 */
            do {
                c4 = str.charCodeAt(i++) & 0xff;
                if (c4 == 61) 
                    return out;
                c4 = base64DecodeChars[c4];
            }
            while (i < len && c4 == -1);
            if (c4 == -1) 
                break;
            out += String.fromCharCode(((c3 & 0x03) << 6) | c4);
        }
        return out;
    }
    /**
     * utf16转utf8
     * @param {Object} str
     */
    function utf16to8(str){
        var out, i, len, c;
        out = "";
        len = str.length;
        for (i = 0; i < len; i++) {
            c = str.charCodeAt(i);
            if ((c >= 0x0001) && (c <= 0x007F)) {
                out += str.charAt(i);
            }
            else 
                if (c > 0x07FF) {
                    out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
                    out += String.fromCharCode(0x80 | ((c >> 6) & 0x3F));
                    out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
                }
                else {
                    out += String.fromCharCode(0xC0 | ((c >> 6) & 0x1F));
                    out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
                }
        }
        return out;
    }
    /**
     * utf8转utf16
     * @param {Object} str
     */
    function utf8to16(str){
        var out, i, len, c;
        var char2, char3;
        out = "";
        len = str.length;
        i = 0;
        while (i < len) {
            c = str.charCodeAt(i++);
            switch (c >> 4) {
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                    // 0xxxxxxx
                    out += str.charAt(i - 1);
                    break;
                case 12:
                case 13:
                    // 110x xxxx 10xx xxxx
                    char2 = str.charCodeAt(i++);
                    out += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
                    break;
                case 14:
                    // 1110 xxxx10xx xxxx10xx xxxx
                    char2 = str.charCodeAt(i++);
                    char3 = str.charCodeAt(i++);
                    out += String.fromCharCode(((c & 0x0F) << 12) | ((char2 & 0x3F) << 6) | ((char3 & 0x3F) << 0));
                    break;
            }
        }
        return out;
    }

    ///core


    //事件派发列表
    var dispatcherList=[];
    //注册view列表
    var viewList=[];

    //生成唯一ID
    function generateId(){
        var id=new Date().getTime()+""+Math.floor(Math.random()*100000)
        return id
    }


    //向app 发送数据
    function sendToApp(sessionId,callback,cmdKey,args){
        addRequest(sessionId,callback,true)
        sendCmdToApp(sessionId,cmdKey,args)
    }
    //向app发送一个带有永久监听的请求
    //会话id,响应函数,指令标识,其他参数
    function sendKeepListenerRequestToApp(sessionId,callback,cmdKey,args){
        //log("sendKeepListenerRequestToApp to app:",arguments)
        addRequest(sessionId,callback,true)
        sendCmdToApp(sessionId,cmdKey,args)
    }
    //发送数据到App 
    //会话id,指令标识,其他参数
    function sendCmdToApp(sessionId,cmdKey,args){
        var obj=new Object();
        obj.sessionId=sessionId;
        obj.cmd=cmdKey
        obj.args=args
        //log("sending cmd to app:"+JSON.stringify(obj))
        if(window.app){
            window.app.executeCmd(base64encode(utf16to8(JSON.stringify(obj))))
        //window.app.executeCmd(JSON.stringify(obj))
        }   
    }

    //处理app的返回
    function onAppResponse(){
        var args=arguments
        //log("js recv AppResponse:"+args[0],"dispatcherList.length:",dispatcherList.length)
        var sessionId=args[0]
        var respArr=[]
        for (var k = 1; k < args.length; k++) {
            respArr.push(args[k])
        };
        //args.shift()
        for(var i=0;i<dispatcherList.length;i++){
            //log("start findingfunction ")
            //log("findingfunction "+dispatcherList[i].func)
            if(dispatcherList[i].id==sessionId){
                //log("findfunction "+dispatcherList[i].func)
                if(respArr.length==1){
                    var result=respArr[0]
                    result=utf8to16(base64decode(result))
                    //log("js recv result:",result)
                    if(String(result)=="null"){
                        result=false
                    }
                    dispatcherList[i].func(result)
                }else{
                    dispatcherList[i].func(respArr)
                }
                if(!dispatcherList[i].isKeep){
                    dispatcherList.splice(i,1)
                }
                break;
            }
        }
    }

    //添加到请求列表 id 请求 id；func 响应回掉; isKeep 是否为永久监听
    function addRequest(id,func,isKeep){
        for (var obj in dispatcherList){
            if(obj.id==id&&obj.func==func){
                return
            }
        }
        if(func){
            //log("adding request",func)
            var obj=new Object()
            obj.id=id
            obj.func=func;
            obj.isKeep=isKeep
            dispatcherList.push(obj)
        }
        
    }
    //从请求列表移除
    function removeRequest(id){
         for(var i=0;i<dispatcherList.length;i++){
            if(dispatcherList[i].id==id){
                dispatcherList.splice(i,1)
                break;
            }
        }    
    }


    //原生方法执行
    /********* 原生 java 方法 反射*********/

    //系统方法用户对java程序的控制
    //执行java静态方法
    function invokeStaticMethod(className,methodName,args,callback){
         args.splice(0,0,methodName)
         args.splice(1,0,className)
         sendToApp(generateId(),callback,"invokeStaticMethod",args);
    }
    //执行当前Activity的方法
    function invokeActivityMethod(methodName,args,callback){
         args.splice(0,0,methodName)
         sendToApp(generateId(),callback,"invokeActivityMethod",args);
    }
    //执行java语句
    //例如要执行 system.get(0).println("123"), methodStr=system.get().println()  methodParams=[[{type:"int",value:0},{type:"String",value:"123"}]]
    //包名需要用#隔开 例如:com#wuba#bangbang#template#utils#javascript#JSUtils.test().tag.toString().length()
    function executeNativeMethod(methodStr,methodParams,callback){
        sendToApp(generateId(),callback,"executeNativeMethod",[methodStr,methodParams]);
    }


    //外部方法

    /*********数据 和 请求*********/
    //post 
    //url post的目标地址
    //params 包含参数的Object 对象
    //callback 返回数据时候的回调
    function postData(url,params,callback){
        sendToApp(generateId(),callback,"postData",[url,params])
    }
    //使用get方式请求数据
    function getData(url,callback){
         sendToApp(generateId(),callback,"getData",[url])
    }

    function sendNotify(notifyEntity){
       sendToApp(generateId(),null,"sendNotify",["notify_js",notifyEntity])
    }

    /***************************/
    //获取用户信息
    function getUserInfo(callback){
        sendToApp(generateId(),callback,"getUserInfo",[])
    }
    //获取mac和Ip
    function getMacAndIp(callback){
        sendToApp(generateId(),callback,"getMacAndIp",[])
    }
    //获取定位数据
    function getLocation(callback){
       sendToApp(generateId(),callback,"getLocation",[])
    }

    //保存到本地
    function saveToLocal(key,valueObj,callback){
      sendToApp(generateId(),callback,"saveToLocal",[key,valueObj])
    }
    //返回本地数据
    function getFromLocal(key,callback){
        sendToApp(generateId(),function(d){
          callback(d)
        },"getFromLocal",[key])
    }
    //日志上报
    function reportLog(){
      var arr=arguments
      if(arr.constructor==String){
         var d=arr
         arr=[d]
      }
      var pArr=[]
      for (var i = 0; i < arr.length; i++) {
        pArr.push({type:"String",value:arr[i]})
      };
      invokeStaticMethod("com.wuba.bangjob.common.utils.log.Logger","trace",pArr,null)
    }
    //分享
    //title 分享标题
    //url 分享的网址
    //pic 分享的图片
    //text 分享的内容
    function share(title,url,pic,text){
        var shareObj=new Object()
        shareObj.title=title
        shareObj.url=url
        shareObj.pic=pic
        shareObj.text=text
        var obj=new Object();
        obj.sessionId=new Date().getTime()+""+Math.floor(Math.random()*100000);
        obj.cmd="share"
        obj.args=[shareObj]
        //log("sending cmd to app:"+JSON.stringify(obj))
        if(window.app){
            window.app.executeCmd(JSON.stringify(obj))
        }   
    }

    exp.finishActivity=finishActivity

    return exp

}
var _BB=new BangBangAndLite()


