(function (window){
	function View(){
		var holderId=""
		var genId="View"+generateId()
		var tag=null;
		//维护监听列表
		//列表中每一项包含为一个Object 包含 id,func
		//id代表注册id，func 代表关联的处理函数.
		var listenerArr=[]
		
		this._getGenId=function(){
			return genId
		}

		this.setEventListener=function (type,func){
			if(this.holderId!=""){
				var reged=false;
				for (var f in listenerArr){
					if(f.func==func&&f.type==type){
						reged=true
						break;
					}
				}
				if(!reged){
					log("setting Listener:"+type)
					var obj=new Object()
					obj.id=generateId();
					obj.func=func
					obj.type=type
					listenerArr.push(obj)
					sendKeepListenerRequestToApp(generateId(),func,type,[this.getBindId()]);
				}
			}else{
			   err(" view not binded!")
			}
		}

		this.getOnClickListenerList=function (){
			return this.onClickListenerArr
		}


	}
	View.prototype.init=function(){
		log("view init",this.holderId)
	}
	View.prototype.getGenId = function() {
		return this._getGenId()
	};
	View.prototype.bindId = function(textName) {
		this.holderId=textName
		return this;
	};
	View.prototype.getBindId = function() {
		return this.holderId
	};
	View.prototype.addEventListener = function(type,func) {
		this.setEventListener(type,func)
	};
	View.prototype.setOnClickListener=function(callback){
		this.setEventListener("setOnClickListener",function(d){
			var evt=generateEvent()
			evt.target=this
			evt.data=d
			callback(evt)
		})
	}
	View.prototype.setOnFocusChangeListener=function(callback){
		this.setEventListener("setOnFocusChangeListener",function(d){
			var evt=generateEvent()
			evt.target=this
			evt.data=(d=="true")
			callback(evt)
		})
	}
	View.prototype.getOnClickListenerList = function() {
		return this.getOnClickListenerList
	};
	//执行JAVA的函数的名字
	//执行JAVA函数的参数
	//执行结束时回调函数
	View.prototype.inVokeMethod=function (methodName,args,callback){
		 args.splice(0,0,methodName)
		 args.splice(1,0,this.holderId)
		 sendToApp(generateId(),callback,"invoke",args);
	}
	//设置交点
	View.prototype.setFocusableInTouchMode=function (focus){
		this.inVokeMethod("setFocusableInTouchMode",[{type:"boolean",value:focus}],null)
	}
	//获取交点
	View.prototype.requestFocus = function() {
		this.inVokeMethod("requestFocus",[],null)
	};
	//移除交点
	View.prototype.requestFocus = function() {
		this.inVokeMethod("requestFocus",[],null)
	};
	//设置focus是否可以获取
	View.prototype.setFocusable = function(focus) {
		this.inVokeMethod("setFocusable",[{type:"boolean",value:focus}],null)
	};

	//设置visiblity  visible 0  invisible 4 gone 8
	View.prototype.setVisibility = function(visibility) {
		this.inVokeMethod("setVisibility",[{type:"int",value:visibility}],null)
	};
	//设置背景图资源 eg ：setBackgroundResource("@drawable/red_edittext_border_background")
	//resIdStr 表示resId的字符串
	View.prototype.setBackgroundResource = function(resIdStr) {
		sendToApp(generateId(),null,"setBackgroundResource",[this.getBindId(),resIdStr])
	};

	//设置一个属性
	View.prototype.setTag=function(o){
		this.tag=o;
	}
	View.prototype.getTag=function(){
		return this.tag;
	}



   
   window.View=View
}(window))