
//事件派发列表
var dispatcherList=[];
//注册view列表
var viewList=[];

//生成唯一ID
function generateId(){
	var id=new Date().getTime()+""+Math.floor(Math.random()*100000)
	return id
}


//向app 发送数据
function sendToApp(sessionId,callback,cmdKey,args){
	addRequest(sessionId,callback,true)
	sendCmdToApp(sessionId,cmdKey,args)
}
//向app发送一个带有永久监听的请求
//会话id,响应函数,指令标识,其他参数
function sendKeepListenerRequestToApp(sessionId,callback,cmdKey,args){
    //log("sendKeepListenerRequestToApp to app:",arguments)
	addRequest(sessionId,callback,true)
	sendCmdToApp(sessionId,cmdKey,args)
}
//发送数据到App 
//会话id,指令标识,其他参数
function sendCmdToApp(sessionId,cmdKey,args){
	var obj=new Object();
	obj.sessionId=sessionId;
	obj.cmd=cmdKey
	obj.args=args
	//log("sending cmd to app:"+JSON.stringify(obj))
	if(window.app){
		window.app.executeCmd(base64encode(utf16to8(JSON.stringify(obj))))
    //window.app.executeCmd(JSON.stringify(obj))
	}	
}

//处理app的返回
function onAppResponse(){
    var args=arguments
    //log("js recv AppResponse:"+args[0],"dispatcherList.length:",dispatcherList.length)
    var sessionId=args[0]
    var respArr=[]
    for (var k = 1; k < args.length; k++) {
    	respArr.push(args[k])
    };
    //args.shift()
    for(var i=0;i<dispatcherList.length;i++){
    	//log("start findingfunction ")
    	//log("findingfunction "+dispatcherList[i].func)
    	if(dispatcherList[i].id==sessionId){
            //log("findfunction "+dispatcherList[i].func)
            if(respArr.length==1){
            	var result=respArr[0]
            	result=utf8to16(base64decode(result))
            	//log("js recv result:",result)
            	if(String(result)=="null"){
            		result=false
            	}
            	dispatcherList[i].func(result)
            }else{
            	dispatcherList[i].func(respArr)
            }
    		if(!dispatcherList[i].isKeep){
    			dispatcherList.splice(i,1)
    		}
    		break;
    	}
    }
}

//添加到请求列表 id 请求 id；func 响应回掉; isKeep 是否为永久监听
function addRequest(id,func,isKeep){
    for (var obj in dispatcherList){
    	if(obj.id==id&&obj.func==func){
    		return
    	}
    }
    if(func){
    	//log("adding request",func)
    	var obj=new Object()
	    obj.id=id
	    obj.func=func;
	    obj.isKeep=isKeep
	    dispatcherList.push(obj)
    }
    
}
//从请求列表移除
function removeRequest(id){
     for(var i=0;i<dispatcherList.length;i++){
    	if(dispatcherList[i].id==id){
    		dispatcherList.splice(i,1)
    		break;
    	}
    }    
}

//生成一个回调事件实例
function generateEvent(eventTarget,eventData){
    var evt=new Object()
    evt.target=eventTarget
    evt.data=eventData
    return evt
}




//界面组件
function getViewById(name){
	for (var i = 0; i < viewList.length; i++) {
		var v=viewList[i]
		if(v.getBindId()==name){
			return v;
		}
	};
	return null;
}
function regView(view,name){
	view.bindId(name)
	//console.log(view,name)
	viewList.push(view)
    view.init();
}

var $View=function (name){
	var ret=getViewById(name)
	if(ret==null){
		ret=new View();
	    regView(ret,name)
	}
	return ret;
}
var $TextView=function (name){
	var ret=getViewById(name)
	if(ret==null){
		ret=new TextView();
	    regView(ret,name)
	}
	return ret;
}

var $EditText=function (name){
	var ret=getViewById(name)
	if(ret==null){
		ret=new EditText();
	    regView(ret,name)
	}
	return ret;
}
var $CheckBox=function (name){
  var ret=getViewById(name)
  if(ret==null){
      ret=new CheckBox();
      regView(ret,name)
  }
  return ret;
}
var $ToggleButton=function (name){
  var ret=getViewById(name)
  if(ret==null){
      ret=new ToggleButton();
      regView(ret,name)
  }
  return ret;
}


